Index: /branches/plugin/bbp-admin/bbp-actions.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-actions.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-actions.php	(revision 3964)
@@ -187,4 +187,2 @@
 	do_action( 'bbp_register_admin_settings' );
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-admin.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-admin.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-admin.php	(revision 3964)
@@ -937,4 +937,2 @@
 	bbpress()->admin->converter = new BBP_Converter();
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-converter.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-converter.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-converter.php	(revision 3964)
@@ -1271,4 +1271,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-forums.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-forums.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-forums.php	(revision 3964)
@@ -590,4 +590,2 @@
 	bbpress()->admin->forums = new BBP_Forums_Admin();
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-functions.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-functions.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-functions.php	(revision 3964)
@@ -211,4 +211,2 @@
 		return $tabs_html;
 	}
-
-?>
Index: /branches/plugin/bbp-admin/bbp-metaboxes.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-metaboxes.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-metaboxes.php	(revision 3964)
@@ -487,4 +487,2 @@
 	do_action( 'bbp_author_metabox', $post_id );
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-replies.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-replies.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-replies.php	(revision 3964)
@@ -969,4 +969,2 @@
 	bbpress()->admin->replies = new BBP_Replies_Admin();
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-settings.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-settings.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-settings.php	(revision 3964)
@@ -1089,4 +1089,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-tools.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-tools.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-tools.php	(revision 3964)
@@ -935,4 +935,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-topics.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-topics.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-topics.php	(revision 3964)
@@ -1040,4 +1040,2 @@
 	bbpress()->admin->topics = new BBP_Topics_Admin();
 }
-
-?>
Index: /branches/plugin/bbp-admin/bbp-users.php
===================================================================
--- /branches/plugin/bbp-admin/bbp-users.php	(revision 3963)
+++ /branches/plugin/bbp-admin/bbp-users.php	(revision 3964)
@@ -111,4 +111,2 @@
 	bbpress()->admin->users = new BBP_Users_Admin();
 }
-
-?>
Index: /branches/plugin/bbp-admin/converters/Example.php
===================================================================
--- /branches/plugin/bbp-admin/converters/Example.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/Example.php	(revision 3964)
@@ -331,3 +331,2 @@
 	}
 }
-?>
Index: /branches/plugin/bbp-admin/converters/Invision.php
===================================================================
--- /branches/plugin/bbp-admin/converters/Invision.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/Invision.php	(revision 3964)
@@ -362,3 +362,2 @@
 	}
 }
-?>
Index: /branches/plugin/bbp-admin/converters/bbPress1.php
===================================================================
--- /branches/plugin/bbp-admin/converters/bbPress1.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/bbPress1.php	(revision 3964)
@@ -527,4 +527,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-admin/converters/index.php
===================================================================
--- /branches/plugin/bbp-admin/converters/index.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/index.php	(revision 3964)
@@ -4,4 +4,2 @@
  * Do not modify the files in this folder.
  */
-
-?>
Index: /branches/plugin/bbp-admin/converters/phpBB.php
===================================================================
--- /branches/plugin/bbp-admin/converters/phpBB.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/phpBB.php	(revision 3964)
@@ -537,4 +537,2 @@
 
 }
-
-?>
Index: /branches/plugin/bbp-admin/converters/vBulletin.php
===================================================================
--- /branches/plugin/bbp-admin/converters/vBulletin.php	(revision 3963)
+++ /branches/plugin/bbp-admin/converters/vBulletin.php	(revision 3964)
@@ -339,3 +339,2 @@
 	}
 }
-?>
Index: /branches/plugin/bbp-admin/index.php
===================================================================
--- /branches/plugin/bbp-admin/index.php	(revision 3963)
+++ /branches/plugin/bbp-admin/index.php	(revision 3964)
@@ -4,4 +4,2 @@
  * Do not modify the files in this folder.
  */
-
-?>
Index: /branches/plugin/bbp-includes/bbp-common-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-common-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-common-functions.php	(revision 3964)
@@ -1627,4 +1627,2 @@
 	$wp_query->set_404();
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-common-template.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-common-template.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-common-template.php	(revision 3964)
@@ -2167,4 +2167,2 @@
 	return apply_filters( 'bbp_title', $title, $sep, $seplocation );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-actions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-actions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-actions.php	(revision 3964)
@@ -539,4 +539,2 @@
 	do_action( 'bbp_after_setup_theme' );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-caps.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-caps.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-caps.php	(revision 3964)
@@ -719,4 +719,2 @@
 	return (bool) apply_filters( 'bbp_current_user_can_see', (bool) $retval, $component );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-classes.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-classes.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-classes.php	(revision 3964)
@@ -379,4 +379,2 @@
 
 endif; // class_exists check
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-filters.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-filters.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-filters.php	(revision 3964)
@@ -294,4 +294,2 @@
 }
 add_filter( 'bbp_after_has_replies_parse_args', '_bbp_has_replies_query' );
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-functions.php	(revision 3964)
@@ -406,4 +406,2 @@
 	return bbpress()->view_id;
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-options.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-options.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-options.php	(revision 3964)
@@ -463,4 +463,2 @@
 	return apply_filters( 'bbp_get_config_location', get_option( 'bb-config-location', $default ) );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-shortcodes.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-shortcodes.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-shortcodes.php	(revision 3964)
@@ -800,4 +800,2 @@
 	bbpress()->shortcodes = new BBP_Shortcodes();
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-update.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-update.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-update.php	(revision 3964)
@@ -210,4 +210,2 @@
 	);
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-core-widgets.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-core-widgets.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-core-widgets.php	(revision 3964)
@@ -819,4 +819,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-extend-akismet.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-extend-akismet.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-extend-akismet.php	(revision 3964)
@@ -697,4 +697,2 @@
 	bbpress()->extend->akismet = new BBP_Akismet();
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-extend-buddypress.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-extend-buddypress.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-extend-buddypress.php	(revision 3964)
@@ -2144,4 +2144,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-forum-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-forum-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-forum-functions.php	(revision 3964)
@@ -2200,4 +2200,2 @@
 	do_action( 'bbp_untrashed_forum', $forum_id );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-forum-template.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-forum-template.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-forum-template.php	(revision 3964)
@@ -2339,4 +2339,2 @@
 		return apply_filters( 'bbp_get_forum_replies_feed_link', $link, $url, $forum_id );
 	}
-
-?>
Index: /branches/plugin/bbp-includes/bbp-reply-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-reply-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-reply-functions.php	(revision 3964)
@@ -1599,4 +1599,2 @@
 	return $reply_position;
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-reply-template.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-reply-template.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-reply-template.php	(revision 3964)
@@ -1980,4 +1980,2 @@
 		return apply_filters( 'bbp_get_form_reply_edit_reason', esc_attr( $reply_edit_reason ) );
 	}
-
-?>
Index: /branches/plugin/bbp-includes/bbp-template-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-template-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-template-functions.php	(revision 3964)
@@ -352,4 +352,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-template-loader.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-template-loader.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-template-loader.php	(revision 3964)
@@ -421,4 +421,2 @@
 	return bbp_get_query_template( 'bbpress', $templates );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-theme-compatibility.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-theme-compatibility.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-theme-compatibility.php	(revision 3964)
@@ -1038,4 +1038,2 @@
 	return apply_filters( 'bbp_force_comment_status', $retval, $open, $post_id, $post_type );
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-topic-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-topic-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-topic-functions.php	(revision 3964)
@@ -3185,4 +3185,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-topic-template.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-topic-template.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-topic-template.php	(revision 3964)
@@ -3498,4 +3498,2 @@
 		return apply_filters( 'bbp_get_form_topic_edit_reason', esc_attr( $topic_edit_reason ) );
 	}
-
-?>
Index: /branches/plugin/bbp-includes/bbp-user-functions.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-user-functions.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-user-functions.php	(revision 3964)
@@ -1402,4 +1402,2 @@
 	}
 }
-
-?>
Index: /branches/plugin/bbp-includes/bbp-user-options.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-user-options.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-user-options.php	(revision 3964)
@@ -280,4 +280,2 @@
 		return apply_filters( 'bbp_get_user_last_posted', $time, $user_id );
 	}
-
-?>
Index: /branches/plugin/bbp-includes/bbp-user-template.php
===================================================================
--- /branches/plugin/bbp-includes/bbp-user-template.php	(revision 3963)
+++ /branches/plugin/bbp-includes/bbp-user-template.php	(revision 3964)
@@ -1530,4 +1530,2 @@
 	return (bool) apply_filters( 'bbp_current_user_can_access_create_reply_form', (bool) $retval );
 }
-
-?>
Index: /branches/plugin/bbp-includes/index.php
===================================================================
--- /branches/plugin/bbp-includes/index.php	(revision 3963)
+++ /branches/plugin/bbp-includes/index.php	(revision 3964)
@@ -4,4 +4,2 @@
  * Do not modify the files in this folder.
  */
-
-?>
Index: /branches/plugin/bbp-languages/index.php
===================================================================
--- /branches/plugin/bbp-languages/index.php	(revision 3963)
+++ /branches/plugin/bbp-languages/index.php	(revision 3964)
@@ -6,4 +6,2 @@
  * Keep custom bbPress translations in /wp-content/languages/bbpress/
  */
-
-?>
Index: /branches/plugin/bbp-theme-compat/bbpress-functions.php
===================================================================
--- /branches/plugin/bbp-theme-compat/bbpress-functions.php	(revision 3963)
+++ /branches/plugin/bbp-theme-compat/bbpress-functions.php	(revision 3964)
@@ -361,4 +361,2 @@
 new BBP_Default();
 endif;
-
-?>
Index: /branches/plugin/bbp-themes/bbp-twentyten/bbpress-functions.php
===================================================================
--- /branches/plugin/bbp-themes/bbp-twentyten/bbpress-functions.php	(revision 3963)
+++ /branches/plugin/bbp-themes/bbp-twentyten/bbpress-functions.php	(revision 3964)
@@ -306,4 +306,2 @@
 new BBP_Twenty_Ten();
 endif;
-
-?>
Index: /branches/plugin/bbp-themes/index.php
===================================================================
--- /branches/plugin/bbp-themes/index.php	(revision 3963)
+++ /branches/plugin/bbp-themes/index.php	(revision 3964)
@@ -6,4 +6,2 @@
  * Keep custom bbPress themes in /wp-content/themes/
  */
-
-?>
Index: /branches/plugin/bbpress.php
===================================================================
--- /branches/plugin/bbpress.php	(revision 3963)
+++ /branches/plugin/bbpress.php	(revision 3964)
@@ -912,4 +912,2 @@
 
 endif; // class_exists check
-
-?>
Index: /branches/plugin/index.php
===================================================================
--- /branches/plugin/index.php	(revision 3963)
+++ /branches/plugin/index.php	(revision 3964)
@@ -4,4 +4,2 @@
  * Do not modify the files in this folder.
  */
-
-?>