Index: /trunk/includes/admin/converters/vBulletin.php
===================================================================
--- /trunk/includes/admin/converters/vBulletin.php	(revision 4271)
+++ /trunk/includes/admin/converters/vBulletin.php	(revision 4272)
@@ -25,5 +25,5 @@
 		/** Forum Section *****************************************************/
 
-		// Forum id. Stored in postmeta.
+		// Forum id (Stored in postmeta)
 		$this->field_map[] = array(
 			'from_tablename' => 'forum',
@@ -33,5 +33,5 @@
 		);
 
-		// Forum parent id.  If no parent, than 0. Stored in postmeta.
+		// Forum parent id (If no parent, than 0. Stored in postmeta)
 		$this->field_map[] = array(
 			'from_tablename' => 'forum',
@@ -49,5 +49,5 @@
 		);
 
-		// Forum slug. Clean name.
+		// Forum slug (Clean name to avoid confilcts)
 		$this->field_map[] = array(
 			'from_tablename'  => 'forum',
@@ -67,5 +67,5 @@
 		);
 
-		// Forum display order.  Starts from 1.
+		// Forum display order (Starts from 1)
 		$this->field_map[] = array(
 			'from_tablename' => 'forum',
@@ -99,5 +99,5 @@
 		/** Topic Section *****************************************************/
 
-		// Topic id. Stored in postmeta.
+		// Topic id (Stored in postmeta)
 		$this->field_map[] = array(
 			'from_tablename' => 'thread',
@@ -107,5 +107,5 @@
 		);
 
-		// Forum id. Stored in postmeta.
+		// Forum id (Stored in postmeta)
 		$this->field_map[] = array(
 			'from_tablename'  => 'thread',
@@ -133,5 +133,5 @@
 		);
 
-		// Topic slug. Clean name.
+		// Topic slug (Clean name to avoid conflicts)
 		$this->field_map[] = array(
 			'from_tablename'  => 'thread',
@@ -142,5 +142,5 @@
 		);
 
-		// Forum id.  If no parent, than 0.
+		// Forum id (If no parent, than 0)
 		$this->field_map[] = array(
 			'from_tablename'  => 'thread',
@@ -152,4 +152,5 @@
 
 		// Topic content.
+		// Note: We join the posts table because topics do not have content.
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -217,5 +218,5 @@
 		/** Post Section ******************************************************/
 
-		// Post id. Stores in postmeta.
+		// Post id (Stores in postmeta)
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -226,5 +227,5 @@
 		);
 
-		// Forum id. Stores in postmeta.
+		// Forum id (Stores in postmeta)
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -235,5 +236,5 @@
 		);
 
-		// Topic id. Stores in postmeta.
+		// Topic id (Stores in postmeta)
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -269,5 +270,5 @@
 		);
 
-		// Topic slug. Clean name.
+		// Topic slug (Clean name)
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -287,5 +288,5 @@
 		);
 
-		// Topic id. If no parent, than 0.
+		// Topic id (If no parent, than 0)
 		$this->field_map[] = array(
 			'from_tablename'  => 'post',
@@ -328,5 +329,5 @@
 		/** User Section ******************************************************/
 
-		// Store old User id. Stores in usermeta.
+		// Store old User id (Stores in usermeta)
 		$this->field_map[] = array(
 			'from_tablename' => 'user',
@@ -336,5 +337,5 @@
 		);
 
-		// Store old User password. Stores in usermeta serialized with salt.
+		// Store old User password (Stores in usermeta serialized with salt)
 		$this->field_map[] = array(
 			'from_tablename'  => 'user',
@@ -345,6 +346,6 @@
 		);
 
-		// Store old User Salt. This is only used for the SELECT row info for
-		// the above password save.
+		// Store old User Salt (This is only used for the SELECT row info for
+		// the above password save)
 		$this->field_map[] = array(
 			'from_tablename' => 'user',
@@ -354,5 +355,5 @@
 		);
 
-		// User password verify class. Stores in usermeta for verifying password.
+		// User password verify class (Stores in usermeta for verifying password)
 		$this->field_map[] = array(
 			'to_type'      => 'user',
@@ -367,4 +368,12 @@
 			'to_type'        => 'user',
 			'to_fieldname'   => 'user_login'
+		);
+
+		// User nice name.
+		$this->field_map[] = array(
+			'from_tablename' => 'user',
+			'from_fieldname' => 'user_nicename',
+			'to_type'        => 'user',
+			'to_fieldname'   => 'user_nicename'
 		);
 