Index: /trunk/includes/common/template-tags.php
===================================================================
--- /trunk/includes/common/template-tags.php	(revision 4690)
+++ /trunk/includes/common/template-tags.php	(revision 4691)
@@ -18,5 +18,5 @@
 /**
  * Ouput the forum URL
- * 
+ *
  * @since bbPress (r3979)
  *
@@ -29,5 +29,5 @@
 	/**
 	 * Return the forum URL
-	 * 
+	 *
 	 * @since bbPress (r3979)
 	 *
@@ -763,5 +763,5 @@
  * @since bbPress (r2789)
  *
- * @global WP_Query $wp_query To check if WP_Query::bbp_is_view is true 
+ * @global WP_Query $wp_query To check if WP_Query::bbp_is_view is true
  * @uses bbp_is_query_name() To get the query name
  * @return bool Is it a view page?
@@ -872,92 +872,83 @@
 	/** Archives **************************************************************/
 
-	if ( bbp_is_forum_archive() )
+	if ( bbp_is_forum_archive() ) {
 		$bbp_classes[] = bbp_get_forum_post_type() . '-archive';
 
-	if ( bbp_is_topic_archive() )
+	} elseif ( bbp_is_topic_archive() ) {
 		$bbp_classes[] = bbp_get_topic_post_type() . '-archive';
 
 	/** Topic Tags ************************************************************/
 
-	if ( bbp_is_topic_tag() ) {
+	} elseif ( bbp_is_topic_tag() ) {
 		$bbp_classes[] = bbp_get_topic_tag_tax_id();
 		$bbp_classes[] = bbp_get_topic_tag_tax_id() . '-' . bbp_get_topic_tag_slug();
 		$bbp_classes[] = bbp_get_topic_tag_tax_id() . '-' . bbp_get_topic_tag_id();
-	}
-
-	if ( bbp_is_topic_tag_edit() ) {
+	} elseif ( bbp_is_topic_tag_edit() ) {
 		$bbp_classes[] = bbp_get_topic_tag_tax_id() . '-edit';
 		$bbp_classes[] = bbp_get_topic_tag_tax_id() . '-' . bbp_get_topic_tag_slug() . '-edit';
 		$bbp_classes[] = bbp_get_topic_tag_tax_id() . '-' . bbp_get_topic_tag_id()   . '-edit';
-	}
 
 	/** Components ************************************************************/
 
-	if ( bbp_is_single_forum() )
+	} elseif ( bbp_is_single_forum() ) {
 		$bbp_classes[] = bbp_get_forum_post_type();
 
-	if ( bbp_is_single_topic() )
+	} elseif ( bbp_is_single_topic() ) {
 		$bbp_classes[] = bbp_get_topic_post_type();
 
-	if ( bbp_is_single_reply() )
+	} elseif ( bbp_is_single_reply() ) {
 		$bbp_classes[] = bbp_get_reply_post_type();
 
-	if ( bbp_is_topic_edit() )
+	} elseif ( bbp_is_topic_edit() ) {
 		$bbp_classes[] = bbp_get_topic_post_type() . '-edit';
 
-	if ( bbp_is_topic_merge() )
+	} elseif ( bbp_is_topic_merge() ) {
 		$bbp_classes[] = bbp_get_topic_post_type() . '-merge';
 
-	if ( bbp_is_topic_split() )
+	} elseif ( bbp_is_topic_split() ) {
 		$bbp_classes[] = bbp_get_topic_post_type() . '-split';
 
-	if ( bbp_is_reply_edit() )
+	} elseif ( bbp_is_reply_edit() ) {
 		$bbp_classes[] = bbp_get_reply_post_type() . '-edit';
-		
-	if ( bbp_is_reply_move() )
+
+	} elseif ( bbp_is_reply_move() ) {
 		$bbp_classes[] = bbp_get_reply_post_type() . '-move';
 
-	if ( bbp_is_single_view() )
+	} elseif ( bbp_is_single_view() ) {
 		$bbp_classes[] = 'bbp-view';
 
 	/** User ******************************************************************/
 
-	if ( bbp_is_single_user_edit() ) {
+	} elseif ( bbp_is_single_user_edit() ) {
 		$bbp_classes[] = 'bbp-user-edit';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_single_user() ) {
+
+	} elseif ( bbp_is_single_user() ) {
 		$bbp_classes[] = 'bbp-user-page';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_user_home() ) {
+
+	} elseif ( bbp_is_user_home() ) {
 		$bbp_classes[] = 'bbp-user-home';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_user_home_edit() ) {
+
+	} elseif ( bbp_is_user_home_edit() ) {
 		$bbp_classes[] = 'bbp-user-home-edit';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_topics_created() ) {
+
+	} elseif ( bbp_is_topics_created() ) {
 		$bbp_classes[] = 'bbp-topics-created';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_favorites() ) {
+
+	} elseif ( bbp_is_favorites() ) {
 		$bbp_classes[] = 'bbp-favorites';
 		$bbp_classes[] = 'single';
 		$bbp_classes[] = 'singular';
-	}
-
-	if ( bbp_is_subscriptions() ) {
+
+	} elseif ( bbp_is_subscriptions() ) {
 		$bbp_classes[] = 'bbp-subscriptions';
 		$bbp_classes[] = 'single';
@@ -968,6 +959,7 @@
 
 	// Add bbPress class if we are within a bbPress page
-	if ( !empty( $bbp_classes ) )
+	if ( !empty( $bbp_classes ) ) {
 		$bbp_classes[] = 'bbPress';
+	}
 
 	// Merge WP classes with bbPress classes and remove any duplicates
@@ -1006,69 +998,70 @@
 	/** Archives **************************************************************/
 
-	if ( bbp_is_forum_archive() )
-		$retval = true;
-
-	elseif ( bbp_is_topic_archive() )
+	if ( bbp_is_forum_archive() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topic_archive() ) {
 		$retval = true;
 
 	/** Topic Tags ************************************************************/
 
-	elseif ( bbp_is_topic_tag() )
-		$retval = true;
-
-	elseif ( bbp_is_topic_tag_edit() )
+	} elseif ( bbp_is_topic_tag() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topic_tag_edit() ) {
 		$retval = true;
 
 	/** Components ************************************************************/
 
-	elseif ( bbp_is_single_forum() )
-		$retval = true;
-
-	elseif ( bbp_is_single_topic() )
-		$retval = true;
-
-	elseif ( bbp_is_single_reply() )
-		$retval = true;
-
-	elseif ( bbp_is_topic_edit() )
-		$retval = true;
-
-	elseif ( bbp_is_topic_merge() )
-		$retval = true;
-
-	elseif ( bbp_is_topic_split() )
-		$retval = true;
-
-	elseif ( bbp_is_reply_edit() )
-		$retval = true;
-
-	elseif ( bbp_is_reply_move() )
-		$retval = true;
-
-	elseif ( bbp_is_single_view() )
+	} elseif ( bbp_is_single_forum() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_single_topic() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_single_reply() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topic_edit() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topic_merge() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topic_split() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_reply_edit() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_reply_move() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_single_view() ) {
 		$retval = true;
 
 	/** User ******************************************************************/
 
-	elseif ( bbp_is_single_user_edit() )
-		$retval = true;
-
-	elseif ( bbp_is_single_user() )
-		$retval = true;
-
-	elseif ( bbp_is_user_home() )
-		$retval = true;
-
-	elseif ( bbp_is_user_home_edit() )
-		$retval = true;
-
-	elseif ( bbp_is_topics_created() )
-		$retval = true;
-
-	elseif ( bbp_is_favorites() )
-		$retval = true;
-
-	elseif ( bbp_is_subscriptions() )
-		$retval = true;
+	} elseif ( bbp_is_single_user_edit() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_single_user() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_user_home() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_user_home_edit() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_topics_created() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_favorites() ) {
+		$retval = true;
+
+	} elseif ( bbp_is_subscriptions() ) {
+		$retval = true;
+	}
 
 	/** Done ******************************************************************/
@@ -1656,5 +1649,5 @@
 	 * @uses wp_editor() To output the WordPress editor
 	 *
-	 * @return string HTML from output buffer 
+	 * @return string HTML from output buffer
 	 */
 	function bbp_get_the_content( $args = array() ) {
@@ -2058,5 +2051,5 @@
 			$front_id = get_option( 'page_on_front' );
 
-			// Set home text to page title			
+			// Set home text to page title
 			if ( !empty( $front_id ) ) {
 				$pre_front_text = get_the_title( $front_id );
@@ -2153,5 +2146,5 @@
 			'before'          => '<div class="bbp-breadcrumb"><p>',
 			'after'           => '</p></div>',
-			
+
 			// Separator
 			'sep'             => is_rtl() ? __( '&lsaquo;', 'bbpress' ) : __( '&rsaquo;', 'bbpress' ),
@@ -2159,5 +2152,5 @@
 			'sep_before'      => '<span class="bbp-breadcrumb-sep">',
 			'sep_after'       => '</span>',
-			
+
 			// Crumbs
 			'crumb_before'    => '',